def fn get_a_procedure$
rem this attempts to let the user choose a procedure
rem if necessary, this re-reads the proc to line file
rem returns the name of the procedure, or "" if pb or error
local any_error%
  if myprocs$(0)='  ':return select_procedure$: rem if array is already filled in
  any_error%=read_all_procedures%
  if any_error%
      error_string$=error_message$(2)&cr$&p_to_l$ : rem can't open it
      print_error any_error%
      procs_to_lines%=0
      return ""
  else
     return select_procedure$
  endif
end def get_a_procedure$
:
def fn read_all_procedures%
rem this reads in all of the procedures/functions that can be found
rem in the p_to_l file
rem this returns 0 if ok, else error code
local lp%,a$,count%,maxx%,arr$(10,10),arr2$(1,1)
  procs_to_lines%=ftopen(p_to_l$)	: rem try to open proc to line file
  if procs_to_lines%<0
    procs_to_lines%=ftopen(default_output_dir$&p_to_l$): rem try to open proc to line file
    if procs_to_lines%<0 :return procs_to_lines%
  endif
  maxx%=100				: rem max nbr of procs/lines
  count%=1
  dim arr$(maxx%,50)
  rep lp%
    if eof(#procs_to_lines%):exit lp%	: rem end of file reached
    input#procs_to_lines%,a$		: rem get a line
    if "function " instr a$
       arr$(count%)=a$(10 to)		: rem this is a function
       count%=count%+1
       if count%>maxx%
	 maxx%=maxx%+50
	 dim arr2$(maxx%+50,50)
	 arrcopy arr$,arr2$
	 dim arr$(maxx%,50)
	 arrcopy arr2$,arr$
       endif
       next lp%
    endif
    if 'procedure ' instr a$
       arr$(count%)= a$(11 to)
       count%=count%+1
       if count%>maxx%
	 maxx%=maxx%+50
	 dim arr2$(maxx%+50,50)
	 arrcopy arr$,arr2$
	 dim arr$(maxx%,50)
	 arrcopy arr2$,arr$
       endif
    endif
  end rep lp%
  CLOSE#procs_to_lines%
  procs_to_lines%=0
  if count%=1:return -10		: rem nothing found!
  dim myprocs$(count%-1,50)
  arrcopy arr$,myprocs$
  asort myprocs$,0			: rem sort array
  myprocs$(0)='  '			: rem show a correctly filled array
  return 0				: rem all was ok!
end def read_all_procedure%
:
def fn select_procedure$
rem this just shows all procedure names and allows one to be selected
local temp%
  temp%=list_select(info_message$(16),myprocs$,,,,,,,-1,-1) : rem show list
  if temp%<1:return ""		 : rem ESC or OK clicked, or first (empty) string selected
  return myprocs$(temp%)
end def select_procedure$
:
