def fn error_in_open_output_files%
rem this opens all outputfiles
rem this sets the global variables:
rem #errfile%		- channel ID for error file
rem #output_file%		- channel ID for output (result) file
rem #lines_to_procs%	- channel ID for lines to procedures file
rem #procs_to_lines%	- channel ID for procedures to lines file
rem this uses the global variable:
rem   default_output_dir$
rem   errfile$
rem   output_file$
rem   l_tp_p$
rem   p_to_l$
rem   sav_file$
rem   generic_file$
rem
rem this returns error if an essential file couldn't be opened
rem in this case, it sets the global error variable error_string$
rem is there is no error, it returns 0
rem v. 1.02 close all opened files if error
local length%
:
  errfile%=topen(errfile$)		: rem try to open
  if errfile%<0
    errfile$=default_output_dir$&errfile$
    errfile%=topen(errfile$)		: rem if open failed, try in default dir
    if errfile%<0:error_string$=error_message$(2)&cr$&errfile$:return errfile%
  endif
:
  length%=len(output_file$)
  if length%<4
     output_file$=default_output_dir$&output_file$
     length%=len(output_file$)
     if length%<4
	error_string$=error_massage$(16)&cr$&output_file$
	close#errfile%
	return -7
     endif
  endif
  if output_file$(length%-3 to length%)<>"_bas"
     output_file$=output_file$&"_bas"
     length%=len(output_file$)
  endif
  output_file%=topen(output_file$)
  if output_file%<0
    output_file$=default_output_dir$&output_file$
    length%=len(output_file$)
    output_file%=topen(output_file$)
    if output_file%<0
       error_string$=error_message$(2)&cr$&output_file$
       close#errfile%
       return output_file%
    endif
  endif
:
  generic_file$=output_file$(1 to length%-4)
  sav_file$=generic_file$&'_sav'
:
  lines_to_procs%=topen(l_to_p$)
  if lines_to_procs%<0
    lines_to_procs%=topen(default_output_dir$&l_to_p$)
    if lines_to_procs%<0
	error_string$=error_message$(2)&cr$&l_to_p$
	close#errfile%
	close#output_file%
	return lines_to_procs%
     endif
  endif
:
  procs_to_lines%=topen(p_to_l$)
  if procs_to_lines%<0
    procs_to_lines%=topen(default_output_dir$&p_to_l$)
    if procs_to_lines%<0
      error_string$=error_message$(2)&cr$&p_to_l$
	error_string$=error_message$(2)&cr$&l_to_p$
	close#errfile%
	close#output_file%
	close#lines_to_procs%
	return procs_to_lines%
     endif
  endif
  return 0
end def error_in_output_files%
:
